variables:
  GIT_DEPTH: 3
  SERVICE_NAME: svelte-ssr-bootstrap

stages:
  - build
  - create image
  - deploy

build:
  image: node:14.15.4-alpine3.10
  stage: build
  script:
    - yarn ci
    - yarn lint
    - yarn svelte-check
    - yarn build:prod
    - yarn build:api
    - yarn ci:prod
  artifacts:
    paths:
      - .bin
      - node_modules
      - public
      - package.json
    expire_in: 1 week

create image:
  image: docker:latest
  services:
    - name: docker:dind
  stage: create image
  dependencies:
    - build
  script:
    - docker build --no-cache -t "${CI_REGISTRY}/${SERVICE_NAME}/${CI_COMMIT_REF_SLUG}:latest" .
    - docker images | grep ${SERVICE_NAME}
    #- docker login -u ${BUILDER_USER} -p ${BUILDER_USER_TOKEN} ${CI_REGISTRY}
    # - docker push "${CI_REGISTRY}/${SERVICE_NAME}/${CI_COMMIT_REF_SLUG}:latest"

deploy:
  image: registry.hub.docker.com/ipushkarskiy/ubuntu-20-04-ssh-client:v8
  stage: deploy
  dependencies:
    - build
  script:
    - echo deploy
    #- scp -r deploy root@my-server.ru:${SERVICE_NAME}/
    #- ssh root@my-server.ru 'cd {SERVICE_NAME}; node deploy/index.js'
#  when: manual
